package com.zhongzheng.modules.activity.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.activity.bo.ActivityConfigurationCourseAddBo;
import com.zhongzheng.modules.activity.bo.ActivityConfigurationCourseQueryBo;
import com.zhongzheng.modules.activity.bo.ActivityConfigurationCourseEditBo;
import com.zhongzheng.modules.activity.domain.ActivityConfigurationCourse;
import com.zhongzheng.modules.activity.mapper.ActivityConfigurationCourseMapper;
import com.zhongzheng.modules.activity.vo.ActivityConfigurationCourseVo;
import com.zhongzheng.modules.activity.service.IActivityConfigurationCourseService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 活动配置关联课程包含范围Service业务层处理
 *
 * @author change
 * @date 2021-05-19
 */
@Service
public class ActivityConfigurationCourseServiceImpl extends ServiceImpl<ActivityConfigurationCourseMapper, ActivityConfigurationCourse> implements IActivityConfigurationCourseService {

    @Override
    public ActivityConfigurationCourseVo queryById(Long configurationId){
        ActivityConfigurationCourse db = this.baseMapper.selectById(configurationId);
        return BeanUtil.toBean(db, ActivityConfigurationCourseVo.class);
    }

    @Override
    public List<ActivityConfigurationCourseVo> queryList(ActivityConfigurationCourseQueryBo bo) {
        LambdaQueryWrapper<ActivityConfigurationCourse> lqw = Wrappers.lambdaQuery();
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ActivityConfigurationCourseVo> entity2Vo(Collection<ActivityConfigurationCourse> collection) {
        List<ActivityConfigurationCourseVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ActivityConfigurationCourseVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ActivityConfigurationCourse> page = (Page<ActivityConfigurationCourse>)collection;
            Page<ActivityConfigurationCourseVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(ActivityConfigurationCourseAddBo bo) {
        ActivityConfigurationCourse add = BeanUtil.toBean(bo, ActivityConfigurationCourse.class);
        validEntityBeforeSave(add);
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(ActivityConfigurationCourseEditBo bo) {
        ActivityConfigurationCourse update = BeanUtil.toBean(bo, ActivityConfigurationCourse.class);
        validEntityBeforeSave(update);
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ActivityConfigurationCourse entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }

    @Override
    public List<Long> selectConfiguraList(Long id) {
        return baseMapper.selectConfiguraList(id);
    }
}
